// Borland C++ Builder
// Copyright (c) 1995, 2002 by Borland Software Corporation
// All rights reserved

// (DO NOT EDIT: machine generated header) 'Restructure.pas' rev: 6.00

#ifndef RestructureHPP
#define RestructureHPP

#pragma delphiheader begin
#pragma option push -w-
#pragma option push -Vx
#include <ShellAPI.hpp>	// Pascal unit
#include <DBTables.hpp>	// Pascal unit
#include <BDE.hpp>	// Pascal unit
#include <DB.hpp>	// Pascal unit
#include <Forms.hpp>	// Pascal unit
#include <Controls.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <Messages.hpp>	// Pascal unit
#include <Windows.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Restructure
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TdBasePxFieldType { pxUnknown, pxAlpha, pxNumber, pxMoney, pxShort, pxLongInteger, pxBCD, pxDate, pxTime, pxTimestamp, pxMemo, pxFormattedMemo, pxGraphic, pxOLE, pxLogical, pxAutoincrement, pxBinary, pxBytes, dbCharacter, dbFloat, dbNumber, dbDate, dbMemo, dbLogical, dbOLE, dbBinary, dbLong, dbDateTime, dbDouble, dbAutoincrement, dbBytes, dbLock };
#pragma option pop

#pragma option push -b-
enum TFieldRights { frReadWrite, frReadOnly, frNone, frUnknown };
#pragma option pop

#pragma option push -b-
enum TTableRights { trNone, trReadOnly, trModify, trInsert, trInsDel, trFull, trUnknown };
#pragma option pop

class DELPHICLASS TFieldDesc;
class PASCALIMPLEMENTATION TFieldDesc : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	AnsiString FName;
	TdBasePxFieldType FFieldType;
	Word FLength;
	Word FPrecision;
	void __fastcall SetName(AnsiString Value);
	void __fastcall SetFieldType(TdBasePxFieldType Value);
	void __fastcall SetLength(Word Value);
	void __fastcall SetPrecision(Word Value);
	
public:
	__fastcall virtual TFieldDesc(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property AnsiString Name = {read=FName, write=SetName};
	__property TdBasePxFieldType FieldType = {read=FFieldType, write=SetFieldType, nodefault};
	__property Word Length = {read=FLength, write=SetLength, nodefault};
	__property Word Precision = {read=FPrecision, write=SetPrecision, nodefault};
public:
	#pragma option push -w-inl
	/* TPersistent.Destroy */ inline __fastcall virtual ~TFieldDesc(void) { }
	#pragma option pop
	
};


#pragma option push -b-
enum TLookupType { ltCurrentField, ltAllCorresponding };
#pragma option pop

#pragma option push -b-
enum TLookupAccess { laFillNoHelp, laHelpAndFill };
#pragma option pop

class DELPHICLASS TValCheckDesc;
class PASCALIMPLEMENTATION TValCheckDesc : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	Dbtables::TTable* Table;
	bool FRequired;
	AnsiString FMinimumValue;
	AnsiString FMaximumValue;
	AnsiString FDefaultValue;
	AnsiString FPicture;
	AnsiString FLookupDatabaseName;
	AnsiString FLookupTableName;
	TLookupType FLookupType;
	TLookupAccess FLookupAccess;
	void __fastcall SetRequired(bool Value);
	void __fastcall SetMinimumValue(AnsiString Value);
	void __fastcall SetMaximumValue(AnsiString Value);
	void __fastcall SetDefaultValue(AnsiString Value);
	void __fastcall SetPicture(AnsiString Value);
	void __fastcall SetLookupDatabaseName(AnsiString Value);
	void __fastcall SetLookupTableName(AnsiString Value);
	void __fastcall SetLookupType(TLookupType Value);
	void __fastcall SetLookupAccess(TLookupAccess Value);
	
public:
	__fastcall virtual TValCheckDesc(void);
	__fastcall virtual ~TValCheckDesc(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property bool Required = {read=FRequired, write=SetRequired, nodefault};
	__property AnsiString MinimumValue = {read=FMinimumValue, write=SetMinimumValue};
	__property AnsiString MaximumValue = {read=FMaximumValue, write=SetMaximumValue};
	__property AnsiString DefaultValue = {read=FDefaultValue, write=SetDefaultValue};
	__property AnsiString Picture = {read=FPicture, write=SetPicture};
	__property AnsiString LookupDatabaseName = {read=FLookupDatabaseName, write=SetLookupDatabaseName};
	__property AnsiString LookupTableName = {read=FLookupTableName, write=SetLookupTableName};
	__property TLookupType LookupType = {read=FLookupType, write=SetLookupType, nodefault};
	__property TLookupAccess LookupAccess = {read=FLookupAccess, write=SetLookupAccess, nodefault};
};


#pragma option push -b-
enum TUpdateRule { urCascade, urRestrict };
#pragma option pop

class DELPHICLASS TRefIntDesc;
class PASCALIMPLEMENTATION TRefIntDesc : public Classes::TPersistent 
{
	typedef Classes::TPersistent inherited;
	
private:
	Dbtables::TTable* Table;
	AnsiString FMasterDatabaseName;
	AnsiString FMasterTableName;
	TUpdateRule FModifyOperation;
	TUpdateRule FDeleteOperation;
	void __fastcall SetMasterTableName(AnsiString Value);
	void __fastcall SetModifyOperation(TUpdateRule Value);
	void __fastcall SetDeleteOperation(TUpdateRule Value);
	
public:
	__fastcall virtual TRefIntDesc(void);
	__fastcall virtual ~TRefIntDesc(void);
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	
__published:
	__property AnsiString MasterDatabaseName = {read=FMasterDatabaseName};
	__property AnsiString MasterTableName = {read=FMasterTableName, write=SetMasterTableName};
	__property TUpdateRule ModifyOperation = {read=FModifyOperation, write=SetModifyOperation, nodefault};
	__property TUpdateRule DeleteOperation = {read=FDeleteOperation, write=SetDeleteOperation, nodefault};
};


typedef void __fastcall (__closure *TFieldInappropriateEvent)(System::TObject* Sender, const TFieldDesc* AField);

class DELPHICLASS TRestructure;
class PASCALIMPLEMENTATION TRestructure : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	Dbtables::TTable* Table;
	AnsiString FDatabaseName;
	AnsiString FTableName;
	TFieldDesc* FField;
	TValCheckDesc* FValCheck;
	TRefIntDesc* FRefInt;
	AnsiString FPassword;
	bool FPackTable;
	Word FPrimaryIndexFieldCount;
	bool lHadPrimaryIndex;
	TFieldInappropriateEvent FOnFieldInappropriate;
	void __fastcall SetDatabaseName(AnsiString Value);
	void __fastcall SetTableName(AnsiString Value);
	void __fastcall SetField(TFieldDesc* Value);
	void __fastcall SetValCheck(TValCheckDesc* Value);
	void __fastcall SetRefInt(TRefIntDesc* Value);
	void __fastcall SetPackTable(bool Value);
	void __fastcall SetPrimaryIndexFieldCount(Word Value);
	
protected:
	Bde::FLDDesc *Fields;
	Bde::CROpType *FieldOperations;
	Bde::VCHKDesc *ValChecks;
	Bde::CROpType *ValCheckOperations;
	Bde::RINTDesc *RefInts;
	Bde::CROpType *RefIntOperations;
	Bde::IDXDesc *Indexes;
	Bde::CROpType *IndexOperations;
	Bde::SECDesc *SecDescs;
	Bde::CROpType *SecDescOperations;
	bool IsProtected;
	void __fastcall CreateFieldDescs(void);
	void __fastcall LoadFieldDescs(void);
	void __fastcall CreateAndLoadFieldDescs(void);
	void __fastcall DestroyFieldDescs(void);
	virtual void __fastcall SetFieldType(Bde::pFLDDesc AField, TdBasePxFieldType AType);
	virtual bool __fastcall FieldAppropriate(void);
	TdBasePxFieldType __fastcall GetFieldType(AnsiString FldName);
	Word __fastcall GetFieldPrecision(AnsiString FldName);
	void __fastcall MoveValChecksInsert(int Position);
	void __fastcall MoveValChecksMove(int OldPos, int NewPos);
	void __fastcall MoveValChecksDrop(int Position);
	bool __fastcall ValCheckToAdd(AnsiString FldName);
	Bde::pFLDDesc __fastcall GetField(AnsiString FldName);
	int __fastcall GetFieldPos(AnsiString FldName);
	int __fastcall GetValCheckPos(AnsiString FldName);
	int __fastcall GetRefIntPos(AnsiString RIName);
	Word __fastcall SetMinMaxDefValue(AnsiString Value, TdBasePxFieldType FldType, Word FldPrec, Byte * NewValCheck);
	AnsiString __fastcall GetMinMaxDefValue(TdBasePxFieldType FldType, Word FldPrec, const Byte * AValCheck);
	Word __fastcall LogicalToPhysical(TdBasePxFieldType AFieldType);
	TdBasePxFieldType __fastcall PhysicalToLogical(Word AFieldType);
	
public:
	AnsiString TableType;
	Word TableLevel;
	int FieldCount;
	int ValCheckCount;
	int RefIntCount;
	int IndexCount;
	int SecDescCount;
	__fastcall virtual TRestructure(Classes::TComponent* AOwner);
	__fastcall virtual ~TRestructure(void);
	void __fastcall GetFieldDesc(int Position);
	virtual int __fastcall FieldByName(AnsiString FldName);
	virtual void __fastcall AddField(bool lAddValChecks);
	virtual void __fastcall InsertField(int Position, bool lAddValChecks);
	virtual void __fastcall MoveField(int OldPos, int NewPos);
	virtual void __fastcall DropField(int Position);
	virtual void __fastcall ChangeField(int Position, bool lChangeValChecks);
	bool __fastcall HasValChecks(AnsiString FldName);
	virtual void __fastcall AddValCheck(AnsiString FldName);
	virtual void __fastcall ChangeValCheck(AnsiString FldName);
	virtual void __fastcall DropValCheck(AnsiString FldName);
	bool __fastcall HasRefInts(void);
	virtual void __fastcall AddRefInt(AnsiString RIName, AnsiString DetIdx);
	virtual void __fastcall DropRefInt(AnsiString RIName);
	void __fastcall AddMasterPassword(AnsiString Password);
	void __fastcall ChangeMasterPassword(AnsiString Password);
	void __fastcall DropMasterPassword(void);
	void __fastcall AddAuxPassword(AnsiString AuxPassword, TTableRights TableRights);
	void __fastcall ChangeAuxPassword(AnsiString OldAuxPassword, AnsiString NewAuxPassword, TTableRights TableRights);
	void __fastcall DropAuxPassword(AnsiString AuxPassword);
	void __fastcall ChangeFieldRights(AnsiString AuxPassword, AnsiString FieldName, TFieldRights Rights);
	void __fastcall Cancel(void);
	void __fastcall Apply(void);
	void __fastcall SortValChecks(void);
	
__published:
	__property TFieldDesc* Field = {read=FField, write=SetField};
	__property TValCheckDesc* ValCheck = {read=FValCheck, write=SetValCheck};
	__property AnsiString DatabaseName = {read=FDatabaseName, write=SetDatabaseName};
	__property AnsiString TableName = {read=FTableName, write=SetTableName};
	__property bool PackTable = {read=FPackTable, write=SetPackTable, nodefault};
	__property TRefIntDesc* RefInt = {read=FRefInt, write=SetRefInt};
	__property Word PrimaryIndexFieldCount = {read=FPrimaryIndexFieldCount, write=SetPrimaryIndexFieldCount, nodefault};
	__property TFieldInappropriateEvent OnFieldInappropriate = {read=FOnFieldInappropriate, write=FOnFieldInappropriate};
};


//-- var, const, procedure ---------------------------------------------------
static const Shortint RestrMaxNumOfTypes = 0x1f;
extern PACKAGE Word RestrPhysicalTypes[31];
extern PACKAGE TdBasePxFieldType RestrLogicalTypes[31];

}	/* namespace Restructure */
using namespace Restructure;
#pragma option pop	// -w-
#pragma option pop	// -Vx

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// Restructure
